Index: drivers/filesystems/btrfs/create.c
===================================================================
--- drivers/filesystems/btrfs/create.c	(révision 75772)
+++ drivers/filesystems/btrfs/create.c	(copie de travail)
@@ -2934,20 +2857,22 @@
         } else {
             WARN("FILE_OPEN_BY_FILE_ID only supported for inodes\n");
             Status = STATUS_NOT_IMPLEMENTED;
+            ExReleaseResourceLite(&Vcb->fcb_lock);
             goto exit;
         }
     } else {
         if (related && fn.Length != 0 && fn.Buffer[0] == '\\') {
             Status = STATUS_OBJECT_NAME_INVALID;
+            ExReleaseResourceLite(&Vcb->fcb_lock);
             goto exit;
         }
-        
-        if (!related && RequestedDisposition != FILE_OPEN && !(Stack->Flags & SL_OPEN_TARGET_DIRECTORY)) {
+
+        if (!related && RequestedDisposition != FILE_OPEN && !(IrpSp->Flags & SL_OPEN_TARGET_DIRECTORY)) {
             ULONG fnoff;
-            
+
             Status = open_fileref(Vcb, &related, &fn, NULL, TRUE, &parsed, &fnoff,
-                                  pool_type, Stack->Flags & SL_CASE_SENSITIVE, Irp);
-            
+                                  pool_type, IrpSp->Flags & SL_CASE_SENSITIVE, Irp);
+
             if (Status == STATUS_OBJECT_NAME_NOT_FOUND)
                 Status = STATUS_OBJECT_PATH_NOT_FOUND;
             else if (Status == STATUS_REPARSE)
@@ -2954,173 +2879,219 @@
                 fileref = related;
             else if (NT_SUCCESS(Status)) {
                 fnoff *= sizeof(WCHAR);
-                fnoff += related->filepart.Length + sizeof(WCHAR);
-                
+                fnoff += (related->dc ? related->dc->name.Length : 0) + sizeof(WCHAR);
+
                 if (related->fcb->atts & FILE_ATTRIBUTE_REPARSE_POINT) {
                     Status = STATUS_REPARSE;
                     fileref = related;
-                    parsed = fnoff - sizeof(WCHAR);
+                    parsed = (USHORT)fnoff - sizeof(WCHAR);
                 } else {
                     fn.Buffer = &fn.Buffer[fnoff / sizeof(WCHAR)];
-                    fn.Length -= fnoff;
+                    fn.Length -= (USHORT)fnoff;
 
-                    Status = open_fileref(Vcb, &fileref, &fn, related, Stack->Flags & SL_OPEN_TARGET_DIRECTORY, &parsed, &fn_offset,
-                                        pool_type, Stack->Flags & SL_CASE_SENSITIVE, Irp);
-                    
+                    Status = open_fileref(Vcb, &fileref, &fn, related, IrpSp->Flags & SL_OPEN_TARGET_DIRECTORY, &parsed, &fn_offset,
+                                          pool_type, IrpSp->Flags & SL_CASE_SENSITIVE, Irp);
+
                     loaded_related = TRUE;
                 }
-                
+
             }
         } else {
-            Status = open_fileref(Vcb, &fileref, &fn, related, Stack->Flags & SL_OPEN_TARGET_DIRECTORY, &parsed, &fn_offset,
-                                  pool_type, Stack->Flags & SL_CASE_SENSITIVE, Irp);
+            Status = open_fileref(Vcb, &fileref, &fn, related, IrpSp->Flags & SL_OPEN_TARGET_DIRECTORY, &parsed, &fn_offset,
+                                  pool_type, IrpSp->Flags & SL_CASE_SENSITIVE, Irp);
         }
     }
-    
+
     if (Status == STATUS_REPARSE) {
         REPARSE_DATA_BUFFER* data;
-        
+
         ExAcquireResourceSharedLite(fileref->fcb->Header.Resource, TRUE);
         Status = get_reparse_block(fileref->fcb, (UINT8**)&data);
         ExReleaseResourceLite(fileref->fcb->Header.Resource);
-        
+
         if (!NT_SUCCESS(Status)) {
             ERR("get_reparse_block returned %08x\n", Status);
-            
-            free_fileref(fileref);
+
+            Status = STATUS_SUCCESS;
+        } else {
+            Status = STATUS_REPARSE;
+            RtlCopyMemory(&Irp->IoStatus.Information, data, sizeof(ULONG));
+
+            data->Reserved = FileObject->FileName.Length - parsed;
+
+            Irp->Tail.Overlay.AuxiliaryBuffer = (void*)data;
+
+            free_fileref(Vcb, fileref);
+            ExReleaseResourceLite(&Vcb->fcb_lock);
+
             goto exit;
         }
-        
-        Status = STATUS_REPARSE;
-        RtlCopyMemory(&Irp->IoStatus.Information, data, sizeof(ULONG));
-        
-        data->Reserved = FileObject->FileName.Length - parsed;
-        
-        Irp->Tail.Overlay.AuxiliaryBuffer = (void*)data;
-        
-        free_fileref(fileref);
-        goto exit;
     }
-    
-    if (NT_SUCCESS(Status) && fileref->deleted) {
-        free_fileref(fileref);
-        
+
+    if (NT_SUCCESS(Status) && fileref->deleted)
         Status = STATUS_OBJECT_NAME_NOT_FOUND;
-    }
-    
+
     if (NT_SUCCESS(Status)) {
         if (RequestedDisposition == FILE_CREATE) {
             TRACE("file %S already exists, returning STATUS_OBJECT_NAME_COLLISION\n", file_desc_fileref(fileref));
             Status = STATUS_OBJECT_NAME_COLLISION;
-            free_fileref(fileref);
+
+            free_fileref(Vcb, fileref);
+            ExReleaseResourceLite(&Vcb->fcb_lock);
+
             goto exit;
         }
     } else if (Status == STATUS_OBJECT_NAME_NOT_FOUND) {
         if (RequestedDisposition == FILE_OPEN || RequestedDisposition == FILE_OVERWRITE) {
             TRACE("file doesn't exist, returning STATUS_OBJECT_NAME_NOT_FOUND\n");
+            ExReleaseResourceLite(&Vcb->fcb_lock);
             goto exit;
         }
     } else if (Status == STATUS_OBJECT_PATH_NOT_FOUND) {
         TRACE("open_fileref returned %08x\n", Status);
+        ExReleaseResourceLite(&Vcb->fcb_lock);
         goto exit;
     } else {
         ERR("open_fileref returned %08x\n", Status);
+        ExReleaseResourceLite(&Vcb->fcb_lock);
         goto exit;
     }
-    
+
     if (NT_SUCCESS(Status)) { // file already exists
         file_ref* sf;
-        
+        BOOL readonly;
+
+        ExReleaseResourceLite(&Vcb->fcb_lock);
+
         if (RequestedDisposition == FILE_SUPERSEDE || RequestedDisposition == FILE_OVERWRITE || RequestedDisposition == FILE_OVERWRITE_IF) {
             LARGE_INTEGER zero;
-            
+
 #ifdef DEBUG_STATS
             open_type = 1;
 #endif
-            if (fileref->fcb->type == BTRFS_TYPE_DIRECTORY || fileref->fcb->subvol->root_item.flags & BTRFS_SUBVOL_READONLY) {
+            if (fileref->fcb->type == BTRFS_TYPE_DIRECTORY || is_subvol_readonly(fileref->fcb->subvol, Irp)) {
                 Status = STATUS_ACCESS_DENIED;
-                free_fileref(fileref);
+
+                ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
+                free_fileref(Vcb, fileref);
+                ExReleaseResourceLite(&Vcb->fcb_lock);
+
                 goto exit;
             }
-            
+
             if (Vcb->readonly) {
                 Status = STATUS_MEDIA_WRITE_PROTECTED;
-                free_fileref(fileref);
+
+                ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
+                free_fileref(Vcb, fileref);
+                ExReleaseResourceLite(&Vcb->fcb_lock);
+
                 goto exit;
             }
-            
+
             zero.QuadPart = 0;
             if (!MmCanFileBeTruncated(&fileref->fcb->nonpaged->segment_object, &zero)) {
                 Status = STATUS_USER_MAPPED_FILE;
-                free_fileref(fileref);
+
+                ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
+                free_fileref(Vcb, fileref);
+                ExReleaseResourceLite(&Vcb->fcb_lock);
+
                 goto exit;
             }
         }
-        
-        SeLockSubjectContext(&Stack->Parameters.Create.SecurityContext->AccessState->SubjectSecurityContext);
-        
-        if (!SeAccessCheck(fileref->fcb->ads ? fileref->parent->fcb->sd : fileref->fcb->sd,
-                           &Stack->Parameters.Create.SecurityContext->AccessState->SubjectSecurityContext,
-                           FALSE, Stack->Parameters.Create.SecurityContext->DesiredAccess, 0, NULL,
-                           IoGetFileObjectGenericMapping(), Stack->Flags & SL_FORCE_ACCESS_CHECK ? UserMode : Irp->RequestorMode,
-                           &granted_access, &Status)) {
-            SeUnlockSubjectContext(&Stack->Parameters.Create.SecurityContext->AccessState->SubjectSecurityContext);
-            WARN("SeAccessCheck failed, returning %08x\n", Status);
-            goto exit;
-        }
-        
-        SeUnlockSubjectContext(&Stack->Parameters.Create.SecurityContext->AccessState->SubjectSecurityContext);
-        
-        // We allow a subvolume root to be opened read-write even if its readonly flag is set, so it can be cleared
-        if (fileref->fcb->subvol->root_item.flags & BTRFS_SUBVOL_READONLY && granted_access &
-            (FILE_WRITE_DATA | FILE_APPEND_DATA | FILE_WRITE_EA | FILE_WRITE_ATTRIBUTES | DELETE | WRITE_OWNER | WRITE_DAC) &&
-            fileref->fcb->inode != SUBVOL_ROOT_INODE) {
-            Status = STATUS_ACCESS_DENIED;
-            free_fileref(fileref);
-            goto exit;
-        }
-        
+
+        if (IrpSp->Parameters.Create.SecurityContext->DesiredAccess != 0) {
+            SeLockSubjectContext(&IrpSp->Parameters.Create.SecurityContext->AccessState->SubjectSecurityContext);
+
+            if (!SeAccessCheck((fileref->fcb->ads || fileref->fcb == Vcb->dummy_fcb) ? fileref->parent->fcb->sd : fileref->fcb->sd,
+                               &IrpSp->Parameters.Create.SecurityContext->AccessState->SubjectSecurityContext,
+                               TRUE, IrpSp->Parameters.Create.SecurityContext->DesiredAccess, 0, NULL,
+                               IoGetFileObjectGenericMapping(), IrpSp->Flags & SL_FORCE_ACCESS_CHECK ? UserMode : Irp->RequestorMode,
+                               &granted_access, &Status)) {
+                SeUnlockSubjectContext(&IrpSp->Parameters.Create.SecurityContext->AccessState->SubjectSecurityContext);
+                TRACE("SeAccessCheck failed, returning %08x\n", Status);
+
+                ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
+                free_fileref(Vcb, fileref);
+                ExReleaseResourceLite(&Vcb->fcb_lock);
+
+                goto exit;
+            }
+
+            SeUnlockSubjectContext(&IrpSp->Parameters.Create.SecurityContext->AccessState->SubjectSecurityContext);
+        } else
+            granted_access = 0;
+
         TRACE("deleted = %s\n", fileref->deleted ? "TRUE" : "FALSE");
-        
+
         sf = fileref;
         while (sf) {
             if (sf->delete_on_close) {
-                WARN("could not open as deletion pending\n");
+                TRACE("could not open as deletion pending\n");
                 Status = STATUS_DELETE_PENDING;
-                
-                free_fileref(fileref);
+
+                ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
+                free_fileref(Vcb, fileref);
+                ExReleaseResourceLite(&Vcb->fcb_lock);
+
                 goto exit;
             }
             sf = sf->parent;
         }
 
-        if (fileref->fcb->atts & FILE_ATTRIBUTE_READONLY) {
-            ACCESS_MASK allowed = DELETE | READ_CONTROL | WRITE_OWNER | WRITE_DAC |
-                                    SYNCHRONIZE | ACCESS_SYSTEM_SECURITY | FILE_READ_DATA |
-                                    FILE_READ_EA | FILE_WRITE_EA | FILE_READ_ATTRIBUTES |
-                                    FILE_WRITE_ATTRIBUTES | FILE_EXECUTE | FILE_LIST_DIRECTORY |
-                                    FILE_TRAVERSE;
+        readonly = (!fileref->fcb->ads && fileref->fcb->atts & FILE_ATTRIBUTE_READONLY) || (fileref->fcb->ads && fileref->parent->fcb->atts & FILE_ATTRIBUTE_READONLY) ||
+                   is_subvol_readonly(fileref->fcb->subvol, Irp) || fileref->fcb == Vcb->dummy_fcb || Vcb->readonly;
 
-            if (fileref->fcb->type == BTRFS_TYPE_DIRECTORY)
-                allowed |= FILE_ADD_SUBDIRECTORY | FILE_ADD_FILE | FILE_DELETE_CHILD;
-            
-            if (granted_access & ~allowed) {
-                Status = STATUS_ACCESS_DENIED;
-                free_fileref(fileref);
+        if (readonly) {
+            ACCESS_MASK allowed;
+
+            allowed = READ_CONTROL | SYNCHRONIZE | ACCESS_SYSTEM_SECURITY | FILE_READ_DATA |
+                      FILE_READ_EA | FILE_READ_ATTRIBUTES | FILE_EXECUTE | FILE_LIST_DIRECTORY |
+                      FILE_TRAVERSE;
+
+            if (!Vcb->readonly && (fileref->fcb == Vcb->dummy_fcb || fileref->fcb->inode == SUBVOL_ROOT_INODE))
+                allowed |= DELETE;
+
+            if (fileref->fcb != Vcb->dummy_fcb && !is_subvol_readonly(fileref->fcb->subvol, Irp) && !Vcb->readonly) {
+                allowed |= WRITE_OWNER | WRITE_DAC | FILE_WRITE_EA | FILE_WRITE_ATTRIBUTES;
+
+                if (!fileref->fcb->ads && fileref->fcb->type == BTRFS_TYPE_DIRECTORY)
+                    allowed |= FILE_ADD_SUBDIRECTORY | FILE_ADD_FILE | FILE_DELETE_CHILD;
+            } else if (fileref->fcb->inode == SUBVOL_ROOT_INODE && is_subvol_readonly(fileref->fcb->subvol, Irp) && !Vcb->readonly) {
+                // We allow a subvolume root to be opened read-write even if its readonly flag is set, so it can be cleared
+
+                allowed |= FILE_WRITE_ATTRIBUTES;
+            }
+
+            if (IrpSp->Parameters.Create.SecurityContext->DesiredAccess & MAXIMUM_ALLOWED) {
+                granted_access &= allowed;
+                IrpSp->Parameters.Create.SecurityContext->AccessState->PreviouslyGrantedAccess &= allowed;
+            } else if (granted_access & ~allowed) {
+                Status = Vcb->readonly ? STATUS_MEDIA_WRITE_PROTECTED : STATUS_ACCESS_DENIED;
+
+                ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
+                free_fileref(Vcb, fileref);
+                ExReleaseResourceLite(&Vcb->fcb_lock);
+
                 goto exit;
             }
         }
-        
+
         if (options & FILE_DELETE_ON_CLOSE && (fileref == Vcb->root_fileref || Vcb->readonly ||
-            fileref->fcb->subvol->root_item.flags & BTRFS_SUBVOL_READONLY || fileref->fcb->atts & FILE_ATTRIBUTE_READONLY)) {
+            is_subvol_readonly(fileref->fcb->subvol, Irp) || readonly)) {
             Status = STATUS_CANNOT_DELETE;
-            free_fileref(fileref);
+
+            ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
+            free_fileref(Vcb, fileref);
+            ExReleaseResourceLite(&Vcb->fcb_lock);
+
             goto exit;
         }
-        
+
         if ((fileref->fcb->type == BTRFS_TYPE_SYMLINK || fileref->fcb->atts & FILE_ATTRIBUTE_REPARSE_POINT) && !(options & FILE_OPEN_REPARSE_POINT))  {
             REPARSE_DATA_BUFFER* data;
-            
+
             /* How reparse points work from the point of view of the filesystem appears to
              * undocumented. When returning STATUS_REPARSE, MSDN encourages us to return
              * IO_REPARSE in Irp->IoStatus.Information, but that means we have to do our own
